addpath(genpath('./dollar_toolbox'));
opts = get_default_opts();

% opts.DNN.model_def_file = './Models/NYU/ROI_ms_raw/deploy.prototxt';
% opts.DNN.model_file = './Models/NYU/ROI_ms_raw/depth_net_ms_raw_iter_301000.caffemodel';

opts.DNN.model_def_file = './Models/IIW/ROI_smaller/deploy.prototxt';
opts.DNN.model_file = './Models/IIW/ROI_smaller/reflectance_net_iter_400000.caffemodel';
opts.DNN.model_file = './Models/MIT/ROI_ms_depth/MITD_ms_iter_63000.caffemodel';
opts.DNN.model_file = './Models/BSDS/ROI_ms/BSDS_ms_iter_73000.caffemodel';

assert(exist(opts.DNN.model_def_file,'file')&&exist(opts.DNN.model_file,'file')); 
caffe('init', opts.DNN.model_def_file, opts.DNN.model_file); 
caffe('set_mode_cpu'); 
caffe('set_phase_test'); 
w = caffe('get_weights'); 
% close all;
%
num_params = [];
mkdir([RESULTS_DIR 'supp/weights/reflectance/']);
for i=1:length(w)
    figure(i); set(gcf,'Position',[0 0 1024 768]);
    which_layer = i; 
    prm = []; 
    curr_w =w(which_layer).weights{1}; 
    num_params(i) = numel(curr_w);
    if (size(curr_w,4)==1) 
        imagesc(curr_w); 
    elseif (size(curr_w,3)==3) 
        curr_w = permute(curr_w,[2 1 3 4]); 
        prm.hasChn = 1; 
        montage2(mat2gray(curr_w),prm); 
    else 
        montage2(mat2gray(curr_w)); 
    end 
    title(sprintf('layer %s weights',w(which_layer).layer_names));
%     set(gcf,'Name',w(which_layer).layer_names);
%     PublishizePlot
%     export_fig(gcf,[RESULTS_DIR 'supp/weights/reflectance/' w(which_layer).layer_names '.png']);
%     close all;
end