INPUT_DIR = [RESULTS_DIR 'IIW/20150413T231134/'];

load([DATA_DIR 'IIW/train_test_split.mat']);

idx = testidx;
%%

whdr{1} = cell(2,1);
whdr_eq{1} = cell(2,1);
whdr_ie{1} = cell(2,1);

for t=1:8
    whdr{t} = zeros(length(idx),1);
    whdr_eq{t} = zeros(length(idx),1);
    whdr_ie{t} = zeros(length(idx),1);
end

for i=1:length(idx)
    fprintf('%d of %d\n',i,length(idx));
    [I,filename] = load_iiw_image(idx(i));
    load(sprintf([DATA_DIR 'IIW/%s_points.mat'],filename),'points');
    load(sprintf([DATA_DIR 'IIW/%s_comps.mat'],filename),'comps');
    
    t=1;
    load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],i),'RR');
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(RR,points,comps,0.1);
    
    t=t+1;
    R_bell = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/bell2014_densecrf/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_bell,points,comps,0.1);
    
    t=t+1;
    R_zhao = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/zhao2012_nonlocal/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_zhao,points,comps,0.1);
    
    t=t+1;
    R_color_retinex = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/grosse2009_color_retinex/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_color_retinex,points,comps,0.1);
    
    t=t+1;
    R_gray_retinex = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/grosse2009_grayscale_retinex/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_gray_retinex,points,comps,0.1);
    
    t=t+1;
    R_shen = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/shen2011_optimization/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_shen,points,comps,0.1);
    
    t=t+1;
    R_garces = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/garces2012_clustering/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_garces,points,comps,0.1);
    
    t=t+1;
    R_baseline_shading = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/baseline_shading/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_baseline_shading,points,comps,0.1);
    
    t=t+1;
    R_baseline_reflectance = srgb2rgb(im2double(imread(sprintf([DATA_DIR 'iiw-decompositions/baseline_reflectance/%s-r.png'],filename))));
    [whdr{t}(i),whdr_eq{t}(i),whdr_ie{t}(i)] = WHDR(R_baseline_reflectance,points,comps,0.1);
end
names = {'ours','densecrf','nonlocal','c_retinex','g_retinex','optimization','clustering','baseline_s','baseline_r'};
%%
showres = @(x,y) fprintf('%s - WHDR: %.4f\n',x,nanmean(y));
cellfun(showres,names,whdr)
cellfun(showres,names,whdr_eq)
cellfun(showres,names,whdr_ie)
%%
% good exmample 67,194,257,301,200,500
ind = 194;
[I,filename] = load_iiw_image(idx(ind));
load(sprintf([DATA_DIR 'IIW/%s_points.mat'],filename),'points');
load(sprintf([DATA_DIR 'IIW/%s_comps.mat'],filename),'comps');
load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],ind),'RR','SS');
S = SS;
% RR = RR - min(RR(:)); RR = RR./max(RR(:));
 RR = RR./max(RR(:));
t = im2double(I);
subplot(2,2,1); showim(RR); title('R');
SS = mean(t,3)./(RR); SS(SS<0) = 0; SS(SS>1.4) = 1.4; SS = mat2gray(SS);
% SS = SS-min(SS(:)); SS = SS./max(SS(:));
subplot(2,2,2); showim(SS); title('SS');
subplot(2,2,3); showim(S); title('S');
R_color = bsxfun(@times,bsxfun(@times,t,1./mean(t,3)),RR); R_color(R_color<0) = 0; R_color(R_color>1) = 1;
subplot(2,2,4); showim(R_color); title('R_color');
%%
imwrite(R_color,sprintf('../Paper/figure/iiw/%d_Rc.png',idx(ind)));
imwrite(RR,sprintf('../Paper/figure/iiw/%d_R.png',idx(ind)));
imwrite(S,sprintf('../Paper/figure/iiw/%d_S.png',idx(ind)));
imwrite(SS,sprintf('../Paper/figure/iiw/%d_SS.png',idx(ind)));
imwrite(I,sprintf('../Paper/figure/iiw/%d_I.png',idx(ind)));
