function class_label = compute_class_label(pA, pB, seg, fgmap)
%
% Decide if class_label == 1 (pA is figure); class_label == 2 (pB is figure)
% or pA == pB (other cases; no or more than 1 intervening contour)
%

% find segment label for the 2 points
segA = seg(pA(1), pA(2));
segB = seg(pB(1), pB(2));

if segA==segB
    class_label = 0;
    return
end

line_inds = drawline(pA,pB,size(seg));


[is,js] = ind2sub(size(seg),line_inds);

% find which point comes first in the line
if sum(([is(1);js(1)]-pA(:)).^2)<sum(([is(1);js(1)]-pB(:)).^2)
    % point A is close
    active_point = 1;
else
    active_point = 2;
end

class_label = -1;
already_set = false; on_contour = false;
for n=1:length(line_inds)
    val = fgmap(line_inds(n));
    if val~=0
        if already_set && ~on_contour
            class_label = -1;
            return;   
        else
          already_set = true;
          on_contour = true;
          if val==1
              class_label = active_point;
          else
              class_label = 3-active_point;
          end
        end
    else
        on_contour = false;
    end
end
    %     
% ic_data = fgmap(line_inds);
% fg_inds = find(ic_data==1);
% 
% % if there's no IC or more than one IC, dicsard pair
% if isempty(fg_inds) %|| length(fg_inds)>2
%     class_label = -1;
% else
%     % find closer point
%     [i_fg,j_fg] = ind2sub(size(seg),line_inds(fg_inds));
%     distsA = sum(bsxfun(@minus,pA(:),[i_fg(:)';j_fg(:)']).^2,1);
%     distsB = sum(bsxfun(@minus,pB(:),[i_fg(:)';j_fg(:)']).^2,1);
%         
% %     if sum((pA(:)-[i_fg;j_fg]).^2)>sum((pB(:)-[i_fg;j_fg]).^2)
%     if min(distsA)>min(distsB)
%         class_label = 2;
%         return;
%     else
%         class_label = 1;
%         return;
%     end
% end 
% check if these are neighboring segments i.e. intervening contour exists
% ic = 0;

% idx1 = find(cid2sid(1, :) == segA & cid2sid(2, :) == segB);
% idx2 = find(cid2sid(2, :) == segA & cid2sid(1, :) == segB);
% 
% if (~isempty(idx1) | ~isempty(idx2))
%   ic = 1;
% end
% 
% class_label = 0;
% if ic == 0
%   return; 
% end

% if pA(2) < pB(2)
%   % list of points between pA and pB
%   x = [pA(2), pB(2)];
%   y = [pA(1), pB(1)];
%   X = pA(2):pB(2);
%   Y = round(interp1(x, y, X));
%   % walk through the points 
%   for i = 1:length(X)
%     if fgmap(Y(i), X(i)) == 1
%       % pA is figure
%       class_label = 1;
%       return;
%     end
%     if fgmap(Y(i), X(i)) == -1
%       % pA is ground
%       class_label = 2;
%       return;
%     end
%   end
% else
%   x = [pB(2), pA(2)];
%   y = [pB(1), pA(1)];
%   X = pB(2):pA(2);
%   Y = round(interp1(x, y, X));
%   % walk through the points 
%   for i = 1:length(X)
%     if fgmap(Y(i), X(i)) == 1
%       % pA is ground
%       class_label = 2;
%       return;
%     end
%     if fgmap(Y(i), X(i)) == -1
%       % pA is figure
%       class_label = 1;
%       return;
%     end
%   end
% end


