function [test_data,train_data,fg_dir_list,fg_list] = generate_bsds_data(opts)

% read in the BSDS figure-ground data and put in into the test_data
% and train_data structures, which contain, an image id, a segmentation
% and a figure-ground segmentation

% get names of test and training images
DATA_DIR = opts.paths.DATA_DIR;
test_list = dir([DATA_DIR 'BSDS300/images/test/*.jpg']);
train_list = dir([DATA_DIR 'BSDS300/images/train/*.jpg']);

fg_dir_list = dir([DATA_DIR 'BSDS300/fgdata/color/']);

fg_dir_list = fg_dir_list(3:end);
to_delete = [];
for i=1:length(fg_dir_list)
    fname = fg_dir_list(i).name;
    if fname(1)=='.'
        to_delete = [to_delete; i];
    end
end
fg_dir_list(to_delete) = [];

for i = 1:length(fg_dir_list)
    fg_list{i} = dir(sprintf([DATA_DIR 'BSDS300/fgdata/color/%s/*.fg'], fg_dir_list(i).name));
end

% all_files = {};
% t = 1;
% for i = 1:length(fg_dir_list)
%     for j=1:length(fg_list{i})
%         fname = fg_list{i}(j).name;
%         if fname(1)~='.'
%             image_id = fname(1:strfind(fname,'-')-1);
%             all_files{t}.name = fname;
%             all_files{t}.image_id = image_id;
%             t=t+1;
%         end
%     end
% end
% 
% test_files = {test_list.name};
% train_files = {train_list.name};

% now read in the data
test_cnt = 1;
train_cnt = 1;
test_data = {};
train_data = {};
for i = 1:length(fg_dir_list)
  fprintf('Processing directory %s\n', fg_dir_list(i).name);
  for j = 1:length(fg_list{i})
    name = fg_list{i}(j).name(1:end-7);
    if name_in_list(name, test_list)
      test_data{test_cnt}.image = imread(sprintf([DATA_DIR 'BSDS300/images/test/%s.jpg'], name));
      test_data{test_cnt}.seg = readSeg(sprintf([DATA_DIR 'BSDS300/human/color/%s/%s.seg'], fg_dir_list(i).name, name));
      bmap = seg2bmap(test_data{test_cnt}.seg);
      [cmap, cid2sid] = seg2cmap(test_data{test_cnt}.seg, bmap);
      fg = readbin(sprintf([DATA_DIR 'BSDS300/fgdata/color/%s/%s'], fg_dir_list(i).name, fg_list{i}(j).name));
      test_data{test_cnt}.fgmap = fg{1};
      test_data{test_cnt}.cid2sid = cid2sid;
      test_data{test_cnt}.name = fg_list{i}(j).name;
 
      test_cnt = test_cnt + 1;
    end
    if name_in_list(name, train_list)
      train_data{train_cnt}.image = imread(sprintf([DATA_DIR 'BSDS300/images/train/%s.jpg'], name));
      train_data{train_cnt}.seg = readSeg(sprintf([DATA_DIR 'BSDS300/human/color/%s/%s.seg'], fg_dir_list(i).name, name));
      bmap = seg2bmap(train_data{test_cnt}.seg);
      [cmap, cid2sid] = seg2cmap(train_data{test_cnt}.seg, bmap);
      fg = readbin(sprintf([DATA_DIR 'BSDS300/fgdata/color/%s/%s'], fg_dir_list(i).name, fg_list{i}(j).name));
      train_data{train_cnt}.fgmap = fg{1};
      train_data{train_cnt}.cid2sid = cid2sid;
      train_data{train_cnt}.name = fg_list{i}(j).name;

      train_cnt = train_cnt + 1;
    end    
  end
end 

% split into test and train
% test_idx = [1:20:400];
% train_idx = setdiff([1:400], test_idx);
% test_data = train_data(test_idx);
% train_data = train_data(train_idx);

function in_list = name_in_list(name, list)
  in_list = false;
  for i = 1:length(list)
    if strcmp(name, list(i).name(1:end-4))
      in_list = true;
    end
  end
  return;
