function [comps,ij] = get_point_pairs(sp_data,second_order)
nsegs = sp_data.nsegs;
ij = [];
for i=1:nsegs
    n_i = sp_data.neighbors{i};
    if second_order
        % get second order neighbors
        n_i_2 = [];
        for j=n_i
            n_i_2 = [n_i_2, sp_data.neighbors{j}];
        end
        n_i = unique(n_i_2);
    end
    n_i(n_i<=i) = [];
    if ~isempty(n_i)    
        ij = [ij; repmat(i,[length(n_i),1]), n_i(:)];
    end
end
ij = unique(ij,'rows');

comps = [];
for k=1:size(ij,1)
    comps(k).point1 = ij(k,1);
    comps(k).point2 = ij(k,2);
end
