function [comps,ij] = get_point_pairs_ms(I,kp_params,points,sp_data)
% multiscale version of get point pairs
min_sep = kp_params.min_sep;
spacings = min_sep*2.^(1:floor(-log(min_sep)/log(2))-1);
[~,ij] = get_point_pairs(sp_data,false);

xs = [points.x];
ys = [points.y];
for s=spacings
   t = kp_params;
   t.min_sep = s;
   [temp_points,temp_sp_data] = extract_key_points(I,t);
   [~,temp_ij] = get_point_pairs(temp_sp_data,false);
   
   txs = [temp_points.x];
   tys = [temp_points.y];
   
   idx = knnsearch([xs(:) ys(:)],[txs(:) tys(:)]);
   
   temp_ij = idx(temp_ij);
   
   ij = [ij; temp_ij];
end    
ij = unique(ij,'rows');
comps = [];
for k=1:size(ij,1)
    comps(k).point1 = ij(k,1);
    comps(k).point2 = ij(k,2);
end

% show_annotations(I,points,comps);
