%% dump david's eigen stuff
load('~/Dropbox (MIT)/data (1)/images_for_eigen/predictions_v1.mat');
mkdir('~/Dropbox (MIT)/data (1)/images_for_eigen/eigen_results');
mkdir('~/Dropbox (MIT)/data (1)/images_for_eigen/eigen_results/make3D/');
mkdir('~/Dropbox (MIT)/data (1)/images_for_eigen/eigen_results/kitti/');
for i=1:length(predictions_v1.names)
    Z = squeeze(predictions_v1.pred_depths(i,:,:));
    Z = Z(12:227,14:305);
    fname = sprintf('%d.png',i);
    imwrite(mat2gray(Z),['~/Dropbox (MIT)/data (1)/images_for_eigen/eigen_results/' fname]);
end

%% dump some of Philip's results
input_dir = '~/Dropbox (MIT)/data (1)/images_for_eigen/our_results/20150424T180502/';
mkdir([input_dir 'cropped/'])
for i=1:47
    fname = sprintf('Z%d.png',i);
    Z = imread([input_dir fname]);
    Z = Z(12:227,14:305);
    imwrite(mat2gray(Z),[input_dir 'cropped/' fname]);
    
    fname = sprintf('I%d.png',i);
    I = imread([input_dir fname]);
    I = I(12:227,14:305,:);
    imwrite(I,[input_dir 'cropped/' fname]);
end

%% some NYU stuff
init_setup;
INPUT_DIR = [RESULTS_DIR 'NYU/20150419T164154/'];%20150419T164154

if ~exist('images','var')
    load([DATA_DIR 'NYU/splits_nyu.mat']);
    load([DATA_DIR 'NYU/nyu_depth_v2_labeled.mat']);
    gt_depths = depths;
end


mean_Z_image = mean(gt_depths(:,:,trainNdxs),3);
mean_Z = mean(mean_Z_image(:));

inds = [197, 166, 312, 114, 111, 76, 123, 544];

load([DATA_DIR 'eigen/predictions_depth.mat']);

idx = testNdxs;

OUT_DIR = [RESULTS_DIR 'supp/NYU_examples/'];
mkdir(OUT_DIR);

fid = fopen([OUT_DIR 'index.html'],'w');
fprintf(fid,'<HTML><BODY><TABLE>\n');
fprintf(fid,'<TR><TD>Input Image</TD><TD>Our Result</TD><TD>Eigen results</TD><TD>Ground Truth</TD></TR>\n');
for i=inds
    fprintf(fid,'<TR>\n');
    I = images(:,:,:,idx(i));
    
    
    load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],i),'data');
    crop = data.opts.crop_region;
    I = I(crop:end-crop,crop:end-crop,:);
    imwrite(mat2gray(I),sprintf([OUT_DIR 'I%d.png'],i));
    Z = data.Z;
    imwrite(mat2gray(Z),sprintf([OUT_DIR 'Z%d.png'],i));
    
    eigen_Z = imresize(depths(:,:,i),2,'bilinear');
    eigen_Z = eigen_Z(crop:end-crop,crop:end-crop);
    
    imwrite(mat2gray(eigen_Z),sprintf([OUT_DIR 'Z%d_eigen.png'],i));
    
    gtZ = gt_depths(:,:,testNdxs(i));
    gtZ = gtZ(crop:end-crop,crop:end-crop);
    imwrite(mat2gray(gtZ),sprintf([OUT_DIR 'Z%d_gt.png'],i));
    fprintf(fid,'<TD><img src=I%d.png></TD><TD><img src=Z%d.png></TD><TD><img src=Z%d_eigen.png></TD><TD><img src=Z%d_gt.png></TD>\n',i,i,i,i);
    fprintf(fid,'</TR>\n');
end
fprintf(fid,'</TABLE></BODY></HTML>\n');
fclose(fid);

%%
INPUT_DIR = [RESULTS_DIR 'IIW/20150413T231134/'];

load([DATA_DIR 'IIW/train_test_split.mat']);

idx = testidx;

% good exmample 67,194,257,301,200,500
inds =  randperm(length(idx)); inds = inds(1:10); inds = inds(:)'; [390   118   487   405   269   125   219   495    28   336];

OUT_DIR = [RESULTS_DIR 'supp/IIW_examples/'];
mkdir(OUT_DIR);

fid = fopen([OUT_DIR 'index.html'],'w');
fprintf(fid,'<HTML><BODY><TABLE>\n');
fprintf(fid,'<TR><TD>Input Image</TD><TD>Grayscale R</TD><TD>Color R</TD><TD>Shading</TD></TR>\n');
k=1;
for ind = inds
    [I,filename] = load_iiw_image(idx(ind));
    load(sprintf([DATA_DIR 'IIW/%s_points.mat'],filename),'points');
    load(sprintf([DATA_DIR 'IIW/%s_comps.mat'],filename),'comps');
    load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],ind),'RR','SS');
    S = SS;
    % RR = RR - min(RR(:)); RR = RR./max(RR(:));
    RR = RR./max(RR(:));
    t = im2double(I);
    
    SS = mean(t,3)./(RR); SS=SS*0.8; SS(SS<0) = 0; SS(SS>1.4) = 1.4; SS = mat2gray(SS);
    % SS = SS-min(SS(:)); SS = SS./max(SS(:));
    t(t<0.1) = 0.1;
    R_color = bsxfun(@times,bsxfun(@times,t,1./mean(t,3)),RR); R_color(R_color<0) = 0; R_color(R_color>1) = 1;


    imwrite(R_color,sprintf([OUT_DIR '%d_Rc.png'],idx(ind)));
    imwrite(RR,sprintf([OUT_DIR '%d_R.png'],idx(ind)));
    imwrite(S,sprintf([OUT_DIR '%d_S.png'],idx(ind)));
    imwrite(SS,sprintf([OUT_DIR '%d_SS.png'],idx(ind)));
    imwrite(I,sprintf([OUT_DIR '%d_I.png'],idx(ind)));
    figure(k);
    showim(SS);
    k=k+1;
    fprintf(fid,'<TD><img src=%d_I.png></TD><TD><img src=%d_R.png></TD><TD><img src=%d_Rc.png></TD><TD><img src=%d_SS.png></TD>\n',idx(ind),idx(ind),idx(ind),idx(ind));
    fprintf(fid,'</TR>\n');
end

fprintf(fid,'</TABLE></BODY></HTML>\n');
fclose(fid);
