% function train_ms_net()
init_setup

run('./matconvnet_dag/matlab/vl_setupnn.m') ;
addpath(['./matconvnet_dag/examples'])
addpath(['./matconvnet_dag/'])
% initialize net
net = init_ms_net();

if ~exist('imdb','var')
    % load data
    load([DATA_DIR '/NYU/MS_raw/train/C.mat']);
    load([DATA_DIR '/NYU/MS_raw/train/M.mat']);
    load([DATA_DIR '/NYU/MS_raw/train/BB.mat']);


    imdb = [];
    imdb.M = cellfun(@(t) (t(:,:,1:2,:)),M,'UniformOutput',false);
    imdb.BB = cellfun(@(t) (t),BB,'UniformOutput',false);
    imdb.C = C+1;
    imdb.images.set = ones(1,length(C));

    % load data
    load([DATA_DIR '/NYU/MS_raw/test/M.mat']);
    load([DATA_DIR '/NYU/MS_raw/test/BB.mat']);
    load([DATA_DIR '/NYU/MS_raw/test/C.mat']);

    test_size = min(size(C,2),10000);
    imdb.M = cellfun(@(a,b) cat(4,a,(b(:,:,1:2,1:test_size))),imdb.M,M,'UniformOutput',false);
    imdb.BB = cellfun(@(a,b) cat(4,a,(b(:,:,:,1:test_size))),imdb.BB,BB,'UniformOutput',false);
    imdb.C = cat(2,imdb.C,C(1,1:test_size)+1);
    imdb.images.set = cat(2,imdb.images.set,2*ones(1,test_size));
    clear M C BB
%    imdb.BB{2} = [];
%    imdb.BB{4} = [];
%    imdb.M{2} = [];
%    imdb.M{4} = [];
end
%%
outputDefs = [];
outputDefs(1).name = 'objective';
outputDefs(1).layerName = 'loss';
outputDefs(1).printfun = @(x) fprintf(1,'objective is %f\n',x);

[net, info] = cnn_dagtrain(net, imdb, @getBatch_ms_augment,outputDefs,...
                        'useGpu',true,'batchSize',128,'learningRate',logspace(-3, -6, 30),...
                    'expDir', fullfile('data','augmented_rot'));


