function train_selection_net()
init_setup

run('./matconvnet_dag/matlab/vl_setupnn.m') ;
addpath(['./matconvnet_dag/examples'])
addpath(['./matconvnet_dag/'])

% initialize net
net = init_selection_net();

% net = [];
% net.layers = {};
% net.layers{end+1} = struct('type', 'conv', 'name', 'hello1', ...
%                            'weights', {{0.1/1 * randn(3, 3, 1, 8, 'single'), []}}, ...
%                            'stride', 1, ...
%                            'pad', 1, ...
%                            'learningRate', [1 2], ...
%                            'weightDecay', [1 0],'inputs','input_image') ;
% net.layers{end+1} = struct('type','custom','name','selection','sz',8,'forward',@selection_forward,'backward',@selection_backward,...
%                             'inputs',{{'coords','hello1'}});
% net.layers{end+1} = struct('type','conv','name','hello2',...
%                             'weights', {{0.1*randn(1,1,16,3,'single'),[]}}, ...
%                             'stride',1,...
%                             'pad',0,...
%                             'inputs',{'selection'});
% 
% net.layers{end+1} = struct('type', 'softmaxloss', 'name', 'loss','inputs', {{net.layers{end}.name,'label'}}) ;
%                        
% I1 = randn(256,232,1);%loadBerkeleyImage(8,1,true);
% I2 = randn(256,232,1);%loadBerkeleyImage(7,1,true);
% inputs(1).name = 'input_image';
% inputs(1).x = im2single(cat(4,I1,I2));
% inputs(2).name = 'coords';
% inputs(2).x = cat(2,[0.1 0.3; 0.2 0.2; 0.8 0.5; 0.3 0.6]);
% inputs(3).name = 'label';
% inputs(3).x = [1 2];
% 
% X0  = im2single(cat(4,I1,I2));
% res = vl_dagnn(net,inputs, struct('name','loss','dzdx',single(1)));
% checkgradhandle(@(X) net_helper(X,net),X0(:),1e-2)
% keyboard

if ~exist('imdb','var')
    opts = get_default_opts();

    opts.NYU_gen.train = 0;
    opts.NYU_gen.data_set = 'NYU/MS_raw_small';
    opts.NYU_gen.annotations_dir = 'nyu_annotations_simple_ms/';
    opts.NYU_gen.closer_field = 'closer_raw';
    opts.NYU_gen.closer_score_field = 'closer_score_raw';

    opts.NYU_gen.comps_per_image = 800; % set -1 to use all


    imdb = [];
    load([DATA_DIR 'NYU/nyu_depth_v2_labeled.mat']);
    load([DATA_DIR 'NYU/splits_nyu.mat']);

    %%
    idx = 1:size(images,4);

    imdb.images.images = images;
    imdb.images.set = [];
    imdb.coords = [];
    imdb.img_ids = [];
    imdb.labels = [];
    
    closer_field = 'closer_raw';
    closer_score_field = 'closer_score_raw';

    for i=1:length(idx)
        ind = idx(i);

        fprintf('processing %d\n',ind);

        %% load image
        
        % load precached json files
        load(sprintf([DATA_DIR 'NYU/%s/%d_comps.mat'],opts.NYU_gen.annotations_dir,ind),'comps','points');

        if strcmp(closer_field,'closer')
            fprintf('removing lots of equality edges\n');
            % randomly sample equality edges so we get roughly 60% equality
            eq_inds = find([comps.(closer_field)]=='E');
            eq_inds = eq_inds(randperm(length(eq_inds)));

            % get number of inequailty edges, if there are non skip image entirely
            num_ie = (length(comps)-length(eq_inds));
            if num_ie==0
               continue
            end

            % prune most of the equality edges, but leave 2 times as many equalities as inequialities
            eq_inds = eq_inds((2*num_ie):end);
            comps(eq_inds) = [];
        end

        % remove edges with closer score < 0
        comps([comps.(closer_score_field)]<0) = [];

        % now randomaly sample comps to use specified number
        comps_per_image = 800;
        if comps_per_image>0 && comps_per_image<length(comps)
            sub_inds = randperm(length(comps));
            sub_inds = sub_inds(comps_per_image+1:end);
            comps(sub_inds) = [];
        end
        
        p1s = [comps.point1];
        i1 = [points(p1s).i]/size(images,1);
        j1 = [points(p1s).j]/size(images,2);
        p2s = [comps.point2];
        i2 = [points(p2s).i]/size(images,1);
        j2 = [points(p2s).j]/size(images,2);

        closer = [comps.(closer_field)];
        tC = zeros(1,length(closer)); tC(closer=='E')=1; tC(closer=='1')=2; tC(closer=='2')=3;
        
        imdb.labels(1,end+1:end+length(tC)) = tC;
        
        imdb.coords(:,end+1:end+length(tC)) = [i1(:)';j1(:)';i2(:)';j2(:)'];
        if ismember(ind,trainNdxs)
            imdb.images.set(1,end+1:end+length(tC)) = ones(1,length(tC));
        else
            imdb.images.set(1,end+1:end+length(tC)) = 2*ones(1,length(tC));
        end
        imdb.img_ids(1,end+1:end+length(tC)) = ones(1,length(tC))*ind;
    end
end

rp = randperm(size(imdb.coords,2));
imdb.coords = imdb.coords(:,rp);
imdb.img_ids = imdb.img_ids(1,rp);
imdb.labels = imdb.labels(1,rp);
imdb.images.set = imdb.images.set(1,rp);
%%
outputDefs = [];
outputDefs(1).name = 'objective';
outputDefs(1).layerName = 'loss';
outputDefs(1).printfun = @(x) fprintf(1,'objective is %f\n',x);

[net, info] = cnn_dagtrain(net, imdb, @getBatch_nyu,outputDefs,...
                        'useGpu',true,'batchSize',32,'learningRate',logspace(-2, -4, 30),...
                    'expDir', fullfile('data','conv_ord2'));


function [f,df] = net_helper(X,net)
X = reshape(X,[32 32 1 2]);
inputs(1).name = 'input_image';
inputs(1).x = im2single(X);
inputs(2).name = 'coords';
inputs(2).x = cat(2,[0.1 0.3; 0.2 0.2; 0.8 0.5; 0.3 0.6]);
inputs(3).name = 'label';
inputs(3).x = [3 3];


res = vl_dagnn(net,inputs, struct('name','loss','dzdx',single(1)));
f = res(end).x; fprintf('f is %f\n',f);
df = res(1).dzdx; df = df(:);

function inputs = getBatch_nyu(imdb,batch)
inputs(1).name = 'input_image';
inputs(1).x = (im2single(imdb.images.images(:,:,:,imdb.img_ids(1,batch))));
inputs(2).name = 'coords';
inputs(2).x = (single(imdb.coords(:,batch)));
inputs(3).name = 'label';
inputs(3).x = (single(imdb.labels(1,batch)));

% randomly swap 1 and 2 and update label accordignaly
to_swap_inds = rand(1,length(batch))>0.5;
inputs(2).x(:,to_swap_inds) = inputs(2).x([3;4;1;2],to_swap_inds);
temp = inputs(3).x;
inputs(3).x(1,to_swap_inds & temp==2) = 3; 
inputs(3).x(1,to_swap_inds & temp==3) = 2; 
              
function net = init_selection_net(varargin)
opts.scale = 1 ;
opts.initBias = 0.1 ;
opts.weightDecay = 1 ;
opts = vl_argparse(opts, varargin) ;

% Define layers
net.layers = {} ;

% Block 1
net = add_block(net, opts, 1, 11, 11, 3, 16, 4, 5,'input_image') ;
net.layers{end+1} = struct('type', 'pool', 'name', 'pool1', ...
                           'method', 'max', ...
                           'pool', [3 3], ...
                           'stride', 2, ...
                           'pad', 0, ...
                           'inputs',{net.layers{end}.name}) ;
net.layers{end+1} = struct('type', 'normalize', 'name', 'norm1', ...
                           'param', [5 1 0.0001/5 0.75], 'inputs',{net.layers{end}.name}) ;

% Block 2
net = add_block(net, opts, 2, 5, 5, 8, 64, 1, 2, net.layers{end}.name) ;
net.layers{end+1} = struct('type', 'pool', 'name', 'pool2', ...
                           'method', 'max', ...
                           'pool', [3 3], ...
                           'stride', 2, ...
                           'pad', 0, ...
                           'inputs',{net.layers{end}.name});
net.layers{end+1} = struct('type', 'normalize', 'name', 'norm2', ...
                           'param', [5 1 0.0001/5 0.75], ...
                           'inputs',{net.layers{end}.name}) ;


% Block 3
net = add_block(net, opts, 3, 3, 3, 32, 64, 1, 1, {net.layers{end}.name}) ;

% Block 4
net = add_block(net, opts, 4, 3, 3, 32, 64, 1, 1, {net.layers{end}.name}) ;

% Block 5
net = add_block(net, opts, 5, 3, 3, 32, 32, 1, 1, {net.layers{end}.name}) ;
net.layers{end+1} = struct('type', 'pool', 'name', 'pool5', ...
                           'method', 'max', ...
                           'pool', [3 3], ...
                           'stride', 2, ...
                           'pad', 0, ...
                           'inputs', {net.layers{end}.name}) ;


net.layers{end+1} = struct('type','custom','name','selection','sz',224,'forward',@selection_forward,'backward',@selection_backward,...
                            'inputs',{{'coords','pool1','pool2','pool5'}});
% % Block 6
net = add_block(net, opts, 6, 1, 1, 224, 128, 1, 0, {net.layers{end}.name}) ;
net.layers{end+1} = struct('type', 'dropout', 'name', 'dropout6', 'rate', 0.5,'inputs',{net.layers{end}.name}) ;
% 
% 
% Block 7
net = add_block(net, opts, 7, 1, 1, 128, 128, 1, 0, {net.layers{end}.name}) ;
net.layers{end+1} = struct('type', 'dropout', 'name', 'dropout7', 'rate', 0.5,'inputs',{net.layers{end}.name}) ;
% 
% Block 8
net = add_block(net, opts, 8, 1, 1, 128, 3, 1, 0, {net.layers{end}.name}) ;
% net.layers(end) = [] ;

% Block 9

net.layers{end+1} = struct('type', 'softmaxloss', 'name', 'loss','inputs', {{net.layers{end}.name,'label'}}) ;

function net = add_block(net, opts, id, h, w, in, out, stride, pad, block_input)
info = vl_simplenn_display(net) ;
fc = (h == info.dataSize(1,end) && w == info.dataSize(2,end)) ;
if fc
  name = 'fc' ;
else
  name = 'conv' ;
end
net.layers{end+1} = struct('type', 'conv', 'name', sprintf('%s%d', name, id), ...
                           'weights', {{0.01/opts.scale * randn(h, w, in, out, 'single'), []}}, ...
                           'stride', stride, ...
                           'pad', pad, ...
                           'learningRate', [1 2], ...
                           'weightDecay', [opts.weightDecay 0],'inputs',block_input) ;
net.layers{end+1} = struct('type', 'relu', 'name', sprintf('relu%d',id),'inputs',sprintf('%s%d', name, id)) ;

function res = selection_forward(l, inputs, output)
res = output;
num_inputs = length(inputs);
% first input is the coords
coords = inputs(1).x;
% the rest should be the layers
% if isempty(res.x)
    res.x = gpuArray(single(zeros(1,1,l.sz,size(inputs(2).x,4))));
% end
last_C = 0;
for i=2:num_inputs
    [H,W,C,N] = size(inputs(i).x);
    is = ceil(coords(1,:)*H);
    js = ceil(coords(2,:)*W);
    inds = sub2ind([H,W],is,js);
    
    C_offsets = (0:(C-1))*H*W;
    N_offsets = (0:(N-1))*H*W*C;
    
    final_inds = bsxfun(@plus,inds(:),C_offsets(:)');
    final_inds = bsxfun(@plus,final_inds',N_offsets(:)');
    
    data = permute(reshape(inputs(i).x(final_inds),C,N),[3 4 1 2]);
    res.x(1,1,last_C + (1:C),:) = data;
    last_C = last_C + C;
end
for i=2:num_inputs
    [H,W,C,N] = size(inputs(i).x);
    is = ceil(coords(3,:)*H);
    js = ceil(coords(4,:)*W);
    inds = sub2ind([H,W],is,js);
    
    C_offsets = (0:(C-1))*H*W;
    N_offsets = (0:(N-1))*H*W*C;
    
    final_inds = bsxfun(@plus,inds(:),C_offsets(:)');
    final_inds = bsxfun(@plus,final_inds',N_offsets(:)');
    
    data = permute(reshape(inputs(i).x(final_inds),C,N),[3 4 1 2]);
    res.x(1,1,last_C + (1:C),:) = data;
    last_C = last_C + C;
end

function res = selection_backward(l, inputs, output)
res = inputs;
num_inputs = length(inputs);

dzdx = output.dzdx;
% first input is the coords
coords = inputs(1).x;
% the rest should be the layers
for i=2:num_inputs
    if isempty(res(i).dzdx)
        res(i).dzdx = 0*res(i).x;
    end
end
last_C = 0;
for i=2:num_inputs
    [H,W,C,N] = size(inputs(i).x);
    is = ceil(coords(1,:)*H);
    js = ceil(coords(2,:)*W);
    
    inds = sub2ind([H,W],is,js);
    
    C_offsets = (0:(C-1))*H*W;
    N_offsets = (0:(N-1))*H*W*C;
    
    final_inds = bsxfun(@plus,inds(:),C_offsets(:)');
    final_inds = bsxfun(@plus,final_inds',N_offsets(:)');
    
    temp = dzdx(1,1,last_C + (1:C),:);
    res(i).dzdx(final_inds) = res(i).dzdx(final_inds) + squeeze(temp);
    
    last_C = last_C + C;
end
for i=2:num_inputs
    [H,W,C,N] = size(inputs(i).x);
    is = ceil(coords(3,:)*H);
    js = ceil(coords(4,:)*W);
    inds = sub2ind([H,W],is,js);
    
    C_offsets = (0:(C-1))*H*W;
    N_offsets = (0:(N-1))*H*W*C;
    
    final_inds = bsxfun(@plus,inds(:),C_offsets(:)');
    final_inds = bsxfun(@plus,final_inds',N_offsets(:)');
    
    temp = dzdx(1,1,last_C + (1:C),:);
    res(i).dzdx(final_inds) = res(i).dzdx(final_inds) + squeeze(temp);
    
    last_C = last_C + C;
end
