function [whdr,whdr_eq,whdr_ie] = WHDR(R,points,comps,delta,relation_field,relation_score)
if ~isfield(points,'ind')
    for p=1:length(points)
        points(p).i = ceil(points(p).y*size(R,1));
        points(p).j = ceil(points(p).x*size(R,2));
        points(p).ind = sub2ind(size(R),points(p).i,points(p).j);
    end
end
if ~exist('relation_field','var')
    relation_field = 'darker';
end
if ~exist('relation_score','var')
    relation_score = 'darker_score';
end


error_sum = 0;
weight_sum = 0;
error_sum_eq = 0;
error_sum_ie = 0;
weight_sum_eq = 0;
weight_sum_ie = 0;

R = mean(R,3);
R(R<1e-10) = 1e-10;
for t=1:length(comps)
    c = comps(t); 
    p1 = points([points.id]==c.point1);
    p2 = points([points.id]==c.point2);
   
    weight = c.(relation_score);
    
    if weight<=0 || isempty(weight)
        continue
    end
    
    if ~p1.opaque || ~p2.opaque
        continue
    end
    
    l1 = R(p1.i,p1.j);
    l2 = R(p2.i,p2.j);
    
    if (l2/l1) >(1.0 + delta)
        alg_darker = '1';
    elseif (l1/l2) >(1.0 + delta)
        alg_darker = '2';
    else
        alg_darker = 'E';
    end
    
    if c.(relation_field)~=alg_darker
        error_sum = error_sum + weight;
        if c.(relation_field)=='E'
            error_sum_eq = error_sum_eq + weight;
        else
            error_sum_ie = error_sum_ie + weight;
        end
    end
    weight_sum = weight_sum + weight;
    if c.(relation_field)=='E'
        weight_sum_eq = weight_sum_eq + weight;
    else
        weight_sum_ie = weight_sum_ie + weight;
    end
end

if weight_sum>0
    whdr = error_sum/weight_sum;
    whdr_eq = error_sum_eq/weight_sum_eq;
    whdr_ie = error_sum_ie/weight_sum_ie;
else
    whdr = NaN
end