function error = zmae(Z_gt, Z_est)

%
% compute the depth error metric
% \min_b 1/n \sum_{x, y} abs(Z_est(x, y) - Z_gt(x, y) - b)
% where b = median(Z_est - Z_gt)
%

%

Z_gt = Z_gt(:);
Z_est = Z_est(:);

Z_gt(isnan(Z_gt)) = [];
Z_est(isnan(Z_est)) = [];

b = median(Z_est - Z_gt);

error = mean(abs(Z_est - Z_gt - b));


